/**
 * Customize default theme styling by overriding CSS variables:
 * https://github.com/vuejs/vitepress/blob/main/src/client/theme-default/styles/vars.css
 */

/**
 * Colors
 *
 * Each colors have exact same color scale system with 3 levels of solid
 * colors with different brightness, and 1 soft color.
 *
 * - `XXX-1`: The most solid color used mainly for colored text. It must
 *   satisfy the contrast ratio against when used on top of `XXX-soft`.
 *
 * - `XXX-2`: The color used mainly for hover state of the button.
 *
 * - `XXX-3`: The color for solid background, such as bg color of the button.
 *   It must satisfy the contrast ratio with pure white (#ffffff) text on
 *   top of it.
 *
 * - `XXX-soft`: The color used for subtle background such as custom container
 *   or badges. It must satisfy the contrast ratio when putting `XXX-1` colors
 *   on top of it.
 *
 *   The soft color must be semi transparent alpha channel. This is crucial
 *   because it allows adding multiple "soft" colors on top of each other
 *   to create a accent, such as when having inline code block inside
 *   custom containers.
 *
 * - `default`: The color used purely for subtle indication without any
 *   special meanings attched to it such as bg color for menu hover state.
 *
 * - `brand`: Used for primary brand colors, such as link text, button with
 *   brand theme, etc.
 *
 * - `tip`: Used to indicate useful information. The default theme uses the
 *   brand color for this by default.
 *
 * - `warning`: Used to indicate warning to the users. Used in custom
 *   container, badges, etc.
 *
 * - `danger`: Used to show error, or dangerous message to the users. Used
 *   in custom container, badges, etc.
 * -------------------------------------------------------------------------- */

:root {
  --vp-c-default-1: var(--vp-c-gray-1);
  --vp-c-default-2: var(--vp-c-gray-2);
  --vp-c-default-3: var(--vp-c-gray-3);
  --vp-c-default-soft: var(--vp-c-gray-soft);

  --vp-c-brand-1: var(--vp-c-indigo-1);
  --vp-c-brand-2: var(--vp-c-indigo-2);
  --vp-c-brand-3: var(--vp-c-indigo-3);
  --vp-c-brand-soft: var(--vp-c-indigo-soft);

  --vp-c-tip-1: var(--vp-c-brand-1);
  --vp-c-tip-2: var(--vp-c-brand-2);
  --vp-c-tip-3: var(--vp-c-brand-3);
  --vp-c-tip-soft: var(--vp-c-brand-soft);

  --vp-c-warning-1: var(--vp-c-yellow-1);
  --vp-c-warning-2: var(--vp-c-yellow-2);
  --vp-c-warning-3: var(--vp-c-yellow-3);
  --vp-c-warning-soft: var(--vp-c-yellow-soft);

  --vp-c-danger-1: var(--vp-c-red-1);
  --vp-c-danger-2: var(--vp-c-red-2);
  --vp-c-danger-3: var(--vp-c-red-3);
  --vp-c-danger-soft: var(--vp-c-red-soft);
}

/**
 * Component: Button
 * -------------------------------------------------------------------------- */

:root {
  --vp-button-brand-border: transparent;
  --vp-button-brand-text: var(--vp-c-white);
  --vp-button-brand-bg: var(--vp-c-brand-3);
  --vp-button-brand-hover-border: transparent;
  --vp-button-brand-hover-text: var(--vp-c-white);
  --vp-button-brand-hover-bg: var(--vp-c-brand-2);
  --vp-button-brand-active-border: transparent;
  --vp-button-brand-active-text: var(--vp-c-white);
  --vp-button-brand-active-bg: var(--vp-c-brand-1);
}

/**
 * Component: Home
 * -------------------------------------------------------------------------- */

:root {
  --vp-home-hero-name-color: transparent;
  --vp-home-hero-name-background: -webkit-linear-gradient(120deg,
      #bd34fe 30%,
      #41d1ff);

  --vp-home-hero-image-background-image: linear-gradient(-45deg,
      #bd34fe 50%,
      #47caff 50%);
  --vp-home-hero-image-filter: blur(44px);
}

@media (width >= 640px) {
  :root {
    --vp-home-hero-image-filter: blur(56px);
  }
}

@media (width >= 960px) {
  :root {
    --vp-home-hero-image-filter: blur(68px);
  }
}

/**
 * Component: Custom Block
 * -------------------------------------------------------------------------- */

:root {
  --vp-custom-block-tip-border: transparent;
  --vp-custom-block-tip-text: var(--vp-c-text-1);
  --vp-custom-block-tip-bg: var(--vp-c-brand-soft);
  --vp-custom-block-tip-code-bg: var(--vp-c-brand-soft);
  --vp-spec-section-bg: #eff8fd;
  --vp-spec-light-fg: #7a7a7a;
}

/**
 * Component: Algolia
 * -------------------------------------------------------------------------- */

.DocSearch {
  --docsearch-primary-color: var(--vp-c-brand-1) !important;
}

:root {
  --vp-code-color: #000;
  --vp-link-visited: #6b4ba1;
  --vp-code-font-size: 1em;
  --vp-custom-block-font-size: 16px;
  --vp-custom-block-code-font-size: 15px;
  --vp-text-inverted: #fff;
  --sv-hover-color: #eee;
  --explanation-color-1: var( --vp-c-indigo-3);
  --explanation-color-2: var(--vp-c-indigo-1);
}

main a:visited {
  color: var(--vp-link-visited);
}

.dark {
  --vp-code-color: var(--vp-c-brand-1);
  --vp-link-visited: #B59DDD;
  --vp-spec-section-bg: #202122;
  --vp-spec-light-fg: #8a8a8a;
  --vp-text-inverted: #1b1b1f;
  --sv-hover-color: #111;
  --explanation-color-1: var( --vp-c-purple-3);
  --explanation-color-2: var(--vp-c-purple-2);
}

.VPSidebarItem .text {
  font-size: 16px;
}

.title {
  font-size: 20px;
}

.vp-doc h2 {
  margin-top: 32px;
  padding-top: 24px;
}

.vp-doc .main-button {
  background-color: var( --vp-c-brand-1 );
  border: 2px solid var( --vp-c-brand-1 );
  border-radius: 2px;
  box-shadow: rgba(0 0 0 / 12%) 0 1px 3px, rgba(0 0 0 / 24%) 0 1px 2px;
  color: var( --vp-text-inverted );
  cursor: pointer;
  display: inline-block;
  font-weight: 600;
  line-height: 1;
  padding: 6px 16px;
  text-align: center;
  text-decoration: none;
  user-select: none;
}

.vp-doc a[class="main-button"]:hover {
  color: var( --vp-text-inverted );
}

/* Landing page app gallery */

#app-gallery {
  display: flex;

  align-content: flex-start;
  flex-flow: row wrap;
  gap: 1rem;

  margin: 20px 0;
  max-width: 100%;
}

.gallery-item {
  display: flex;

  min-width: 50%;
  max-width: 100%;

  background-color: var( --vp-c-bg-soft );
  border: 1px solid var( --vp-c-divider );
  flex-direction: column;
  flex: 1 0px;
  padding: 4px;
}

@media (width >= 640px) {
  .gallery-item {
    min-width: 40%;
    max-width: 100%;
  }
}

@media (width >= 960px) {
  .gallery-item {
    min-width: 30%;
    max-width: 50%;
  }
}

.gallery-item-heading {
  margin-bottom: 8px;
  text-align: center;
}

.gallery-item-image {
  max-height: 260px;
}

.gallery-item-image img {
  object-fit: contain;

  height: 100%;
  width: 100%;
}

/* Sandbox explanation */

.explanation {
  display: flex;
  justify-content: center;
  margin: 4px 0;
}

.explanation .side {
  width: 100%;
  height: 7px;
  align-self: center;
}

.explanation .side.start {
  background-image: linear-gradient(to left, var( --explanation-color-1 ), var( --explanation-color-2 ));
}

.explanation .side.end {
  background-image: linear-gradient(to right, var( --explanation-color-1), var( --explanation-color-2 ));
}

.explanation .note {
  text-align: center;
  width: 42rem;
  background-color: var(--vp-c-bg);
  font-weight: 600;
}

.explanation.under {
  margin-top: 0.78rem;
}

@media (width >= 640px) {
  .explanation .note {
    width: 36rem;
  }
}

.spec-view {
  min-height: 62px;
}

footer.VPFooter {
  display: block !important;
}
